package com.goldencode.testcases;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.persist.*;
import com.goldencode.testcases.dmo.vtest.*;

import static com.goldencode.p2j.util.BlockManager.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in Vadim22.p).
 */
public class Vadim22
{
   Btest.Buf btest = RecordBuffer.define(Btest.Buf.class, "vtest", "btest");

   Btest.Buf hbuffer = RecordBuffer.define(Btest.Buf.class, "vtest", "hbuffer");

   final QueryWrapper query0 = new QueryWrapper(false);

   /**
    * External procedure (converted to Java from the 4GL source code
    * in Vadim22.p).
    */
   public void execute()
   {
      externalProcedure(new Block()
      {
         logical log = new logical(false);

         integer int1 = new integer(0);

         rowid row = new rowid();

         handle hBuffer = new handle();

         handle hQuery = new handle();

         handle hBuf = new handle();

         character ch = new character("");

         handle hField = new handle();

         public void init()
         {
            TransactionManager.register(log, int1, row, hBuf);
         }

         public void body()
         {
            RecordBuffer.openScope(btest);
            UnnamedStreams.assignOut(StreamFactory.openFileStream("vadim22_results", true, false));
            hBuf.assign(hBuffer);
            handle.unwrapBufferField(hBuffer).value();
            handle.unwrapErrorStatus(hBuffer).setError(log);
            log.assign(handle.unwrapErrorStatus(hBuffer).isError());
            log.assign(handle.unwrapQuery(hQuery).getNumResults());
            int1.assign(handle.unwrapQuery(hQuery).getTableCount());
            int1.assign(handle.unwrapBuffer(hBuffer).numFields());
            row.assign(handle.unwrapBuffer(hBuffer).rowID());
            log.assign(handle.unwrapBuffer(hBuffer).locked());
            ch.assign(handle.unwrapBuffer(hBuffer).initial());
            log.assign(handle.unwrapBuffer(hBuffer).ambiguous());
            hField.assign(handle.unwrapBuffer(hBuffer).bufferField(5));
            ch.assign(handle.unwrapBufferField(hField).columnLabel());
            int1.assign(handle.unwrapBufferField(hField).extent());
            ch.assign(handle.unwrapBufferField(hField).format());
            ch.assign(handle.unwrapBufferField(hField).stringValue());
            handle.unwrapBufferField(hField).changeValue(handle.unwrapBufferField(hField).value());
            handle.unwrapBufferField(hBuffer).changeValue(handle.unwrapBufferField(hBuffer).value(7));
            handle.unwrapBufferField(hBuffer).changeValue(4, handle.unwrapBufferField(hBuffer).value(6));
            handle.unwrapBufferField(hField).changeColumnLabel(ch);
            ch.assign(handle.unwrapBufferField(hField).stringValue(1));
            /*  NEW TESTS */
            ch.assign(handle.unwrapBufferField(hField).bufferName());
            ch.assign(handle.unwrapBufferField(hField).bufferName());
            ch.assign(handle.unwrapQuery(hQuery).indexInformation());
            ch.assign(handle.unwrapQuery(hQuery).indexInformation());
            ch.assign(handle.unwrapQuery(hQuery).indexInformation(11));
            log.assign(handle.unwrapBufferField(hField).literalQuestion());
            handle.unwrapBufferField(hField).changeLiteralQuestion(log);
            handle.unwrapBufferField(hField).changeLiteralQuestion(handle.unwrapBufferField(hField).literalQuestion());
            handle.unwrapBufferField(hField).changeLiteralQuestion(handle.unwrapBufferField(hField).literalQuestion());
            handle.unwrapBufferField(hField).changeLiteralQuestion(handle.unwrapBufferField(hField).literalQuestion());
            ch.assign(handle.unwrapBufferField(hField).validateMessage());
            handle.unwrapBufferField(hField).changeValidateMessage(ch);
            handle.unwrapBufferField(hField).changeValidateMessage(handle.unwrapBufferField(hField).validateMessage());
            handle.unwrapBufferField(hField).changeValidateMessage(ch);
            int1.assign(handle.unwrapQuery(hQuery).currentRow());
            int1.assign(handle.unwrapQuery(hQuery).currentRow());
            log.assign(handle.unwrapBufferField(hField).mandatory());
            log.assign(handle.unwrapBufferField(hField).mandatory());
            ch.assign(handle.unwrapBufferField(hField).validateExpression());
            ch.assign(handle.unwrapBufferField(hField).validateExpression());
            handle.unwrapBufferField(hField).changeValidateExpression(ch);
            handle.unwrapBufferField(hField).changeValidateExpression(ch);
            int1.assign(handle.unwrapBufferField(hBuffer).currentIteration());
            int1.assign(handle.unwrapBufferField(hBuffer).currentIteration());
            log.assign(handle.unwrapQuery(hQuery).forwardOnly());
            log.assign(handle.unwrapQuery(hQuery).forwardOnly());
            handle.unwrapQuery(hQuery).changeForwardOnly(log);
            handle.unwrapQuery(hQuery).changeForwardOnly(log);
            row.assign(handle.unwrapBuffer(hBuffer).rowID());
            row.assign(handle.unwrapBuffer(hBuffer).rowID());
            row.assign(handle.unwrapBuffer(hBuffer).recordID());
            row.assign(handle.unwrapBuffer(hBuffer).recordID());
            ch.assign(handle.unwrapQuery(hQuery).prepareString());
            ch.assign(handle.unwrapQuery(hQuery).prepareString());
         }
      });
   }
}
